<template>
  <div class="auth">
    <div class="authorization" :class="{active : isAuthorizationShown}">
      <button class="close-btn" type="button" name="close" @click="close">
        <img src="@/assets/img/svg/close.svg" alt="close">
      </button>
      <component :is="chosenAuthComponent"></component>
      <div class="authorization__footer" v-if="chosenAuthComponent === 'reg'">
        Have an account? <a class="link" @click.prevent='signIn' href="#">Log In</a>
      </div>
      <div class="authorization__footer" v-else>
        Don't have an account? <a class="link" @click.prevent='createAccount' href="#">Create account</a>
      </div>
    </div>
    <div @click="close" class="auth__overlay" :class="{active : isAuthorizationShown}"></div>
  </div>
</template>

<script>
import Log from '@/components/Authorization/Log';
import Reg from '@/components/Authorization/Reg';
import ResetPass from '@/components/Authorization/ResetPass';
import CreatePass from '@/components/Authorization/CreatePass';
import {mapGetters, mapMutations} from 'vuex';

export default {
  inject: ['stopSkroll'],
  name: 'Authorization',
  components:{
    Log,
    Reg,
    ResetPass,
    CreatePass
  },
  methods: {
    ...mapMutations(['UPDATE_AUTH_COMPONENT']),
    signIn() {
      this.UPDATE_AUTH_COMPONENT({name: 'log', isShown: true});
    },
    createAccount() {
      this.UPDATE_AUTH_COMPONENT({name: 'reg', isShown: true});
    },
    close() {
      this.UPDATE_AUTH_COMPONENT({isShown: false});
    },
    closeAuthWithEsc (e) {
      if (e.keyCode === 27 && this.isAuthorizationShown) {
        this.close();
      }
    }
  },
  computed: {
    ...mapGetters({
      chosenAuthComponent: 'getAuthComponentName',
      isAuthorizationShown: 'getAuthShowParameter'
    })
  },
  watch: {
    isAuthorizationShown() {
      this.stopSkroll(this.isAuthorizationShown);
    }
  },
  created () {
    document.addEventListener('keydown', this.closeAuthWithEsc);
  },
  destroyed () {
    document.removeEventListener('keydown', this.closeAuthWithEsc);
  },
  mounted() {
    this.UPDATE_AUTH_COMPONENT({});
    if (this.$route.params.name) {
      this.UPDATE_AUTH_COMPONENT({name: this.$route.params.name, isShown: true});
    }
  }
}
</script>

<style lang="sass" scoped>
.authorization
  position: fixed
  top: 0
  bottom: 0
  right: 0
  width: 35%
  height: auto
  background-color: white
  z-index: 1000
  padding: rem(30)
  border: 1px solid rgba(#e0e0e0, 0.5)
  transform: translateX(100%)
  transition: all .3s
  display: flex
  flex-direction: column
  justify-content: space-between
  overflow: auto
  &.active
    transform: translateX(0)
  &__footer
    font-family: $mainFont
    font-size: rem(14)
    color: #636E7E
    align-self: flex-start
    margin-top: rem(50)
.auth__overlay
  position: fixed
  top: 0
  left: 0
  right: 0
  bottom: 0
  width: 100%
  height: 100%
  background-color: #000521
  opacity: 0.7
  z-index: 900
  display: none
  &.active
    display: block
.close-btn
  position: absolute
  top: rem(24)
  right: rem(24)
</style>